diff --git a/media/webrtc/trunk/webrtc/build/extra_gitignore.py b/media/webrtc/trunk/webrtc/build/extra_gitignore.py
index f8496686bb..536b83b1a0 100755
--- a/media/webrtc/trunk/webrtc/build/extra_gitignore.py
+++ b/media/webrtc/trunk/webrtc/build/extra_gitignore.py
@@ -28,7 +28,7 @@ def main(argv):
 
   modify_string = MODIFY_STRING % argv[0]
   gitignore_file = os.path.dirname(argv[0]) + '/../../.gitignore'
-  lines = open(gitignore_file, 'r').readlines()
+  lines = open(gitignore_file).readlines()
   for i, line in enumerate(lines):
     # Look for modify_string in the file to ensure we don't append the extra
     # patterns more than once.
@@ -39,7 +39,7 @@ def main(argv):
 
   f = open(gitignore_file, 'w')
   f.write(''.join(lines))
-  f.write(open(argv[1], 'r').read())
+  f.write(open(argv[1]).read())
   f.close()
 
 if __name__ == '__main__':
diff --git a/media/webrtc/trunk/webrtc/build/gyp_webrtc.py b/media/webrtc/trunk/webrtc/build/gyp_webrtc.py
index 87d8a57ddf..4335ccfd4d 100644
--- a/media/webrtc/trunk/webrtc/build/gyp_webrtc.py
+++ b/media/webrtc/trunk/webrtc/build/gyp_webrtc.py
@@ -21,4 +21,4 @@
 import os
 
 path = os.path.abspath(os.path.split(__file__)[0])
-execfile(os.path.join(path, 'gyp_webrtc'))
+exec(compile(open(os.path.join(path, 'gyp_webrtc'), "rb").read(), os.path.join(path, 'gyp_webrtc'), 'exec'))
diff --git a/media/webrtc/trunk/webrtc/build/merge_libs.py b/media/webrtc/trunk/webrtc/build/merge_libs.py
index 84904d61ce..4cd54f84d3 100644
--- a/media/webrtc/trunk/webrtc/build/merge_libs.py
+++ b/media/webrtc/trunk/webrtc/build/merge_libs.py
@@ -79,7 +79,7 @@ def main(argv):
                     ' -exec', cmd, output_lib, '{} +'])
   else:
     cmd = ' '.join([cmd + output_lib] + FindFiles(search_path, pattern))
-  print cmd
+  print(cmd)
   subprocess.check_call(cmd, shell=True)
   return 0
 
diff --git a/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_decoder.py b/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_decoder.py
index b7b7ddd4a6..e85fcd66e3 100755
--- a/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_decoder.py
+++ b/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_decoder.py
@@ -48,15 +48,15 @@ def convert_yuv_to_png_files(yuv_file_name, yuv_frame_width, yuv_frame_height,
              % yuv_file_name, '-f', 'image2', '-vcodec', 'png',
              '%s' % output_files_pattern]
   try:
-    print 'Converting YUV file to PNG images (may take a while)...'
-    print ' '.join(command)
+    print('Converting YUV file to PNG images (may take a while)...')
+    print(' '.join(command))
     helper_functions.run_shell_command(
         command, fail_msg='Error during YUV to PNG conversion')
-  except helper_functions.HelperError, err:
-    print 'Error executing command: %s. Error: %s' % (command, err)
+  except helper_functions.HelperError as err:
+    print('Error executing command: {}. Error: {}'.format(command, err))
     return False
   except OSError:
-    print ('Did not find %s. Have you installed it?' % ffmpeg_path)
+    print('Did not find %s. Have you installed it?' % ffmpeg_path)
     return False
   return True
 
@@ -82,7 +82,7 @@ def decode_frames(input_directory, zxing_path):
   """
   if not zxing_path:
     zxing_path = 'zxing.exe' if sys.platform == 'win32' else 'zxing'
-  print 'Decoding barcodes from PNG files with %s...' % zxing_path
+  print('Decoding barcodes from PNG files with %s...' % zxing_path)
   return helper_functions.perform_action_on_all_files(
       directory=input_directory, file_pattern='frame_',
       file_extension='png', start_number=1, action=_decode_barcode_in_file,
@@ -106,12 +106,12 @@ def _decode_barcode_in_file(file_name, command_line_decoder):
     text_file = open('%s.txt' % file_name[:-4], 'w')
     text_file.write(out)
     text_file.close()
-  except helper_functions.HelperError, err:
-    print 'Barcode in %s cannot be decoded.' % file_name
-    print err
+  except helper_functions.HelperError as err:
+    print('Barcode in %s cannot be decoded.' % file_name)
+    print(err)
     return False
   except OSError:
-    print ('Did not find %s. Have you installed it?' % command_line_decoder)
+    print('Did not find %s. Have you installed it?' % command_line_decoder)
     return False
   return True
 
@@ -127,7 +127,7 @@ def _generate_stats_file(stats_file_name, input_directory='.'):
   file_prefix = os.path.join(input_directory, 'frame_')
   stats_file = open(stats_file_name, 'w')
 
-  print 'Generating stats file: %s' % stats_file_name
+  print('Generating stats file: %s' % stats_file_name)
   for i in range(1, _count_frames_in(input_directory=input_directory) + 1):
     frame_number = helper_functions.zero_pad(i)
     barcode_file_name = file_prefix + frame_number + '.txt'
@@ -160,7 +160,7 @@ def _read_barcode_from_text_file(barcode_file_name):
   Return:
     (string): The decoded barcode.
   """
-  barcode_file = open(barcode_file_name, 'r')
+  barcode_file = open(barcode_file_name)
   barcode = barcode_file.read()
   barcode_file.close()
   return barcode
@@ -180,8 +180,8 @@ def _check_barcode(barcode):
   if len(barcode) != 12:
     return False
 
-  r1 = range(0, 11, 2)  # Odd digits
-  r2 = range(1, 10, 2)  # Even digits except last
+  r1 = list(range(0, 11, 2))  # Odd digits
+  r2 = list(range(1, 10, 2))  # Even digits except last
   dsum = 0
   # Sum all the even digits
   for i in r1:
@@ -272,19 +272,19 @@ def _main():
                                   options.yuv_frame_height,
                                   output_directory=options.png_working_dir,
                                   ffmpeg_path=options.ffmpeg_path):
-    print 'An error occurred converting from YUV to PNG frames.'
+    print('An error occurred converting from YUV to PNG frames.')
     return -1
 
   # Decode the barcodes from the PNG frames.
   if not decode_frames(input_directory=options.png_working_dir,
                        zxing_path=options.zxing_path):
-    print 'An error occurred decoding barcodes from PNG frames.'
+    print('An error occurred decoding barcodes from PNG frames.')
     return -2
 
   # Generate statistics file.
   _generate_stats_file(options.stats_file,
                        input_directory=options.png_working_dir)
-  print 'Completed barcode decoding.'
+  print('Completed barcode decoding.')
   return 0
 
 if __name__ == '__main__':
diff --git a/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_encoder.py b/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_encoder.py
index 3a8f35499d..937b64fc27 100755
--- a/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_encoder.py
+++ b/media/webrtc/trunk/webrtc/tools/barcode_tools/barcode_encoder.py
@@ -59,7 +59,7 @@ def generate_upca_barcodes(number_of_barcodes, barcode_width, barcode_height,
       helper_functions.run_shell_command(
           command, fail_msg=('Error during barcode %s generation' % content))
     except helper_functions.HelperError as err:
-      print >> sys.stderr, err
+      print(err, file=sys.stderr)
       errors = True
   return not errors
 
@@ -111,7 +111,7 @@ def _convert_to_yuv_and_delete(output_directory, file_name, pattern):
                            file_name))
     os.remove(file_name)
   except helper_functions.HelperError as err:
-    print >> sys.stderr, err
+    print(err, file=sys.stderr)
     return False
   return True
 
@@ -154,7 +154,7 @@ def _add_to_file_and_delete(output_file, file_name):
   try:
     os.remove(file_name)
   except OSError as e:
-    print >> sys.stderr, 'Error deleting file %s.\nError: %s' % (file_name, e)
+    print('Error deleting file {}.\nError: {}'.format(file_name, e), file=sys.stderr)
     return False
   return True
 
diff --git a/media/webrtc/trunk/webrtc/tools/barcode_tools/build_zxing.py b/media/webrtc/trunk/webrtc/tools/barcode_tools/build_zxing.py
index 466bd50fd9..35080879b1 100755
--- a/media/webrtc/trunk/webrtc/tools/barcode_tools/build_zxing.py
+++ b/media/webrtc/trunk/webrtc/tools/barcode_tools/build_zxing.py
@@ -25,11 +25,11 @@ def run_ant_build_command(path_to_ant_build_file):
     process = subprocess.Popen(cmd, stdout=sys.stdout, stderr=sys.stderr)
     process.wait()
     if process.returncode != 0:
-      print >> sys.stderr, 'Failed to execute: %s' % ' '.join(cmd)
+      print('Failed to execute: %s' % ' '.join(cmd), file=sys.stderr)
     return process.returncode
   except subprocess.CalledProcessError as e:
-    print >> sys.stderr, 'Failed to execute: %s.\nCause: %s' % (' '.join(cmd),
-                                                                e)
+    print('Failed to execute: {}.\nCause: {}'.format(' '.join(cmd),
+                                                                e), file=sys.stderr)
     return -1
 
 def _main():
diff --git a/media/webrtc/trunk/webrtc/tools/barcode_tools/helper_functions.py b/media/webrtc/trunk/webrtc/tools/barcode_tools/helper_functions.py
index bb0b167334..75702fb375 100644
--- a/media/webrtc/trunk/webrtc/tools/barcode_tools/helper_functions.py
+++ b/media/webrtc/trunk/webrtc/tools/barcode_tools/helper_functions.py
@@ -52,7 +52,7 @@ def run_shell_command(cmd_list, fail_msg=None):
   output, error = process.communicate()
   if process.returncode != 0:
     if fail_msg:
-      print >> sys.stderr, fail_msg
+      print(fail_msg, file=sys.stderr)
     raise HelperError('Failed to run %s: command returned %d and printed '
                       '%s and %s' % (' '.join(cmd_list), process.returncode,
                                      output, error))
diff --git a/media/webrtc/trunk/webrtc/tools/compare_videos.py b/media/webrtc/trunk/webrtc/tools/compare_videos.py
index f6275a67d3..b5167cdc03 100755
--- a/media/webrtc/trunk/webrtc/tools/compare_videos.py
+++ b/media/webrtc/trunk/webrtc/tools/compare_videos.py
@@ -99,7 +99,7 @@ def main():
 
   # On Windows, sometimes the inherited stdin handle from the parent process
   # fails. Work around this by passing null to stdin to the subprocesses.
-  null_filehandle = open(os.devnull, 'r')
+  null_filehandle = open(os.devnull)
 
   # Run barcode decoder on the test video to identify frame numbers.
   png_working_directory = tempfile.mkdtemp()
@@ -122,7 +122,7 @@ def main():
 
   shutil.rmtree(png_working_directory)
   if barcode_decoder.returncode != 0:
-    print 'Failed to run barcode decoder script.'
+    print('Failed to run barcode decoder script.')
     return 1
 
   # Run frame analyzer to compare the videos and print output.
@@ -139,7 +139,7 @@ def main():
                                     stdout=sys.stdout, stderr=sys.stderr)
   frame_analyzer.wait()
   if frame_analyzer.returncode != 0:
-    print 'Failed to run frame analyzer.'
+    print('Failed to run frame analyzer.')
     return 1
 
   return 0
diff --git a/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/perf/perf_utils.py b/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/perf/perf_utils.py
index 77eda1e7a3..82b4f0c7f2 100644
--- a/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/perf/perf_utils.py
+++ b/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/perf/perf_utils.py
@@ -25,7 +25,7 @@ def PrintPerfResult(graph_name, series_name, data_point, units,
                        this test on the waterfall page, not the stdio page).
   """
   waterfall_indicator = ['', '*'][show_on_waterfall]
-  print '%sRESULT %s: %s= %s %s' % (
+  print('{}RESULT {}: {}= {} {}'.format(
       waterfall_indicator, graph_name, series_name,
-      str(data_point).replace(' ', ''), units)
+      str(data_point).replace(' ', ''), units))
   sys.stdout.flush()
\ No newline at end of file
diff --git a/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/run_audio_test.py b/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/run_audio_test.py
index 51caa42cd9..52f42cf943 100755
--- a/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/run_audio_test.py
+++ b/media/webrtc/trunk/webrtc/tools/e2e_quality/audio/run_audio_test.py
@@ -52,7 +52,7 @@ def main(argv):
 
   # Get the initial default capture device, to restore later.
   command = ['pacmd', 'list-sources']
-  print ' '.join(command)
+  print(' '.join(command))
   proc = subprocess.Popen(command, stdout=subprocess.PIPE)
   output = proc.communicate()[0]
   if proc.returncode != 0:
@@ -67,14 +67,14 @@ def main(argv):
   # We pass the render device for VoiceEngine to select because (for unknown
   # reasons) the virtual device is sometimes not used when the default.
   command = ['pacmd', 'set-default-source', options.play_sink + '.monitor']
-  print ' '.join(command)
+  print(' '.join(command))
   retcode = subprocess.call(command, stdout=subprocess.PIPE)
   if retcode != 0:
     return retcode
 
   command = [options.harness, '--render=' + options.rec_sink,
       '--codec=' + options.codec, '--rate=' + options.rate]
-  print ' '.join(command)
+  print(' '.join(command))
   voe_proc = subprocess.Popen(command)
 
   # If recording starts before there is data available, pacat sometimes
@@ -87,12 +87,12 @@ def main(argv):
       '--channels=' + options.channels, '--raw']
   command = (['pacat', '-p', '-d', options.play_sink] + format_args +
       [options.input])
-  print ' '.join(command)
+  print(' '.join(command))
   play_proc = subprocess.Popen(command)
 
   command = (['pacat', '-r', '-d', options.rec_sink + '.monitor'] +
       format_args + [options.output])
-  print ' '.join(command)
+  print(' '.join(command))
   record_proc = subprocess.Popen(command)
 
   retcode = play_proc.wait()
@@ -104,14 +104,14 @@ def main(argv):
 
   # Restore the initial default capture device.
   command = ['pacmd', 'set-default-source', default_source]
-  print ' '.join(command)
+  print(' '.join(command))
   retcode = subprocess.call(command, stdout=subprocess.PIPE)
   if retcode != 0:
     return retcode
 
   if options.compare and options.regexp:
     command = shlex.split(options.compare) + [options.input, options.output]
-    print ' '.join(command)
+    print(' '.join(command))
     proc = subprocess.Popen(command, stdout=subprocess.PIPE)
     output = proc.communicate()[0]
     if proc.returncode != 0:
diff --git a/netwerk/dns/prepare_tlds.py b/netwerk/dns/prepare_tlds.py
index a97b20948c..4e05530e9c 100644
--- a/netwerk/dns/prepare_tlds.py
+++ b/netwerk/dns/prepare_tlds.py
@@ -50,7 +50,10 @@ def _normalizeHostname(domain):
   def convertLabel(label):
     if _isASCII(label):
       return label.lower()
-    return encodings.idna.ToASCII(label)
+    result = encodings.idna.ToASCII(label)
+    if isinstance(result, bytes):
+      result = result.decode('ascii')
+    return result
   return ".".join(map(convertLabel, domain.split(".")))
 
 def _isASCII(s):
diff --git a/nsprpub/automation/release/nspr-release-helper.py b/nsprpub/automation/release/nspr-release-helper.py
index f62b80404a..0199fc48e2 100644
--- a/nsprpub/automation/release/nspr-release-helper.py
+++ b/nsprpub/automation/release/nspr-release-helper.py
@@ -4,6 +4,7 @@
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
 
+from __future__ import print_function
 import os
 import sys
 import datetime
@@ -17,7 +18,7 @@ f_conf = "configure"
 f_conf_in = "configure.in"
 
 def check_call_noisy(cmd, *args, **kwargs):
-    print("Executing command:", cmd)
+    print(("Executing command:", cmd))
     check_call(cmd, *args, **kwargs)
 
 o = OptionParser(usage="client.py [options] remove_beta | set_beta | print_library_versions | set_version_to_minor_release | set_version_to_patch_release | create_nspr_release_archive")
@@ -30,7 +31,7 @@ except IndexError:
     sys.exit(2)
 
 def exit_with_failure(what):
-    print("failure: ", what)
+    print(("failure: ", what))
     sys.exit(2)
 
 def check_files_exist():
@@ -144,12 +145,12 @@ def create_nspr_release_archive():
     check_call_noisy(["mkdir", "-p", nspr_stagedir])
     check_call_noisy(["hg", "archive", "-r", nsprreltag, "--prefix=nspr-" + nsprrel + "/nspr",
                       "../stage/v" + nsprrel + "/src/" + nspr_tar, "-X", ".hgtags"])
-    print("changing to directory " + nspr_stagedir)
+    print(("changing to directory " + nspr_stagedir))
     os.chdir(nspr_stagedir)
 
     check_call("sha1sum " + nspr_tar + " > SHA1SUMS", shell=True)
     check_call("sha256sum " + nspr_tar + " > SHA256SUMS", shell=True)
-    print("created directory " + nspr_stagedir + " with files:")
+    print(("created directory " + nspr_stagedir + " with files:"))
     check_call_noisy(["ls", "-l"])
 
 if action in ('remove_beta'):
diff --git a/nsprpub/build/win32/pgomerge.py b/nsprpub/build/win32/pgomerge.py
index 313d66870d..cbc9dbe672 100644
--- a/nsprpub/build/win32/pgomerge.py
+++ b/nsprpub/build/win32/pgomerge.py
@@ -8,6 +8,7 @@
 # $PWD/$basename.pgd using pgomgr, then deletes them.
 # No errors if any of these files don't exist.
 
+from __future__ import print_function
 import sys, os, os.path, subprocess
 if not sys.platform == "win32":
     raise Exception("This script was only meant for Windows.")
@@ -39,6 +40,6 @@ def MergePGOFiles(basename, pgddir, pgcdir):
 
 if __name__ == '__main__':
   if len(sys.argv) != 3:
-      print >>sys.stderr, "Usage: pgomerge.py <binary basename> <dist/bin>"
+      print("Usage: pgomerge.py <binary basename> <dist/bin>", file=sys.stderr)
       sys.exit(1)
   MergePGOFiles(sys.argv[1], os.getcwd(), sys.argv[2])
diff --git a/old-configure.in b/old-configure.in
index ad404f2051..5049804f57 100644
--- a/old-configure.in
+++ b/old-configure.in
@@ -3637,7 +3637,7 @@ if test -f "${srcdir}/${MOZ_BUILD_APP}/configure.in" ; then
     _subconfigure_subdir="$1"
     _subconfigure_config_args="$ac_configure_args"
   }
-  tmpscript=`$PYTHON -c 'import os, tempfile; print tempfile.mktemp(prefix="subscript.").replace(os.sep, "/")'` || exit 1
+  tmpscript=`$PYTHON -c 'import os, tempfile; print(tempfile.mktemp(prefix="subscript.").replace(os.sep, "/"))'` || exit 1
   ${TOOLCHAIN_PREFIX}m4 "${srcdir}/build/autoconf/subconfigure.m4" \
      "${srcdir}/build/autoconf/altoptions.m4" \
      "${srcdir}/${MOZ_BUILD_APP}/configure.in" > $tmpscript
diff --git a/other-licenses/ply/ply/lex.py b/other-licenses/ply/ply/lex.py
index 267ec100fc..6885ed6736 100644
--- a/other-licenses/ply/ply/lex.py
+++ b/other-licenses/ply/ply/lex.py
@@ -39,7 +39,7 @@ import re, sys, types, copy, os
 # This tuple contains known string types
 try:
     # Python 2.6
-    StringTypes = (types.StringType, types.UnicodeType)
+    StringTypes = (bytes, str)
 except AttributeError:
     # Python 3.0
     StringTypes = (str, bytes)
@@ -49,7 +49,7 @@ except AttributeError:
 
 if sys.version_info[0] < 3:
     def func_code(f):
-        return f.func_code
+        return f.__code__
 else:
     def func_code(f):
         return f.__code__
@@ -177,7 +177,7 @@ class Lexer:
         tf.write("# %s.py. This file automatically created by PLY (version %s). Don't edit!\n" % (tabfile,__version__))
         tf.write("_tabversion   = %s\n" % repr(__version__))
         tf.write("_lextokens    = %s\n" % repr(self.lextokens))
-        tf.write("_lexreflags   = %s\n" % repr(self.lexreflags))
+        tf.write("_lexreflags   = %d\n" % int(self.lexreflags))
         tf.write("_lexliterals  = %s\n" % repr(self.lexliterals))
         tf.write("_lexstateinfo = %s\n" % repr(self.lexstateinfo))
 
@@ -505,6 +505,8 @@ def _form_master_re(relist,reflags,ldict,toknames):
     except Exception:
         m = int(len(relist)/2)
         if m == 0: m = 1
+        if m >= len(relist):
+            raise
         llist, lre, lnames = _form_master_re(relist[:m],reflags,ldict,toknames)
         rlist, rre, rnames = _form_master_re(relist[m:],reflags,ldict,toknames)
         return llist+rlist, lre+rre, lnames+rnames
diff --git a/other-licenses/ply/ply/yacc.py b/other-licenses/ply/ply/yacc.py
index e9f5c65755..a7038f8ed6 100644
--- a/other-licenses/ply/ply/yacc.py
+++ b/other-licenses/ply/ply/yacc.py
@@ -89,21 +89,21 @@ import re, types, sys, os.path
 # Compatibility function for python 2.6/3.0
 if sys.version_info[0] < 3:
     def func_code(f):
-        return f.func_code
+        return f.__code__
 else:
     def func_code(f):
         return f.__code__
 
 # Compatibility
 try:
-    MAXINT = sys.maxint
+    MAXINT = sys.maxsize
 except AttributeError:
     MAXINT = sys.maxsize
 
 # Python 2.x/3.0 compatibility.
 def load_ply_lex():
     if sys.version_info[0] < 3:
-        import lex
+        from . import lex
     else:
         import ply.lex as lex
     return lex
@@ -1844,7 +1844,7 @@ class LRTable(object):
 
     def read_pickle(self,filename):
         try:
-            import cPickle as pickle
+            import six.moves.cPickle as pickle
         except ImportError:
             import pickle
 
@@ -2665,7 +2665,7 @@ del _lr_goto_items
 
     def pickle_table(self,filename,signature=""):
         try:
-            import cPickle as pickle
+            import six.moves.cPickle as pickle
         except ImportError:
             import pickle
         outf = open(filename,"wb")
diff --git a/parser/html/java/htmlparser/generate-encoding-data.py b/parser/html/java/htmlparser/generate-encoding-data.py
index 69b2fdc309..8466dd2e05 100644
--- a/parser/html/java/htmlparser/generate-encoding-data.py
+++ b/parser/html/java/htmlparser/generate-encoding-data.py
@@ -608,16 +608,16 @@ final class Big5Data {
 
 bits = []
 for (low, high) in astral_ranges:
-  for i in xrange(low, high):
+  for i in range(low, high):
     bits.append(1 if index[i] > 0xFFFF else 0)
 # pad length to multiple of 16
-for j in xrange(16 - (len(bits) % 16)):
+for j in range(16 - (len(bits) % 16)):
   bits.append(0)
 
 i = 0
 while i < len(bits):
   accu = 0
-  for j in xrange(16):
+  for j in range(16):
     accu |= bits[i + j] << j
   if accu == 0x22:
     class_file.write('\\"')
@@ -632,7 +632,7 @@ class_file.write('''";
 j = 0
 for (low, high) in ranges:
   class_file.write('''    private static final String TABLE%d = "''' % j)
-  for i in xrange(low, high):
+  for i in range(low, high):
     class_file.write('\\u%04X' % (index[i] & 0xFFFF))
   class_file.write('''";
 
@@ -704,7 +704,7 @@ prefer_last = [
 
 for code_point in prefer_last:
   # Python lists don't have .rindex() :-(
-  for i in xrange(len(index) - 1, -1, -1):
+  for i in range(len(index) - 1, -1, -1):
     candidate = index[i]
     if candidate == code_point:
        class_file.write('''                case 0x%04X:
diff --git a/python/PyECC/ecc/Key.py b/python/PyECC/ecc/Key.py
index 8ba2685768..998e03f610 100644
--- a/python/PyECC/ecc/Key.py
+++ b/python/PyECC/ecc/Key.py
@@ -168,11 +168,12 @@ prime having great security characteristics, 521 bits are preferred
 over a constructed 512 bit field.)
 """
 
-from encoding import *
-from eccrypt import *
-import ecdsa
+from __future__ import print_function
+from .encoding import *
+from .eccrypt import *
+from . import ecdsa
 import hashlib
-from SecurityViolationException import *
+from .SecurityViolationException import *
 
 class Key:
 
@@ -214,7 +215,7 @@ class Key:
         if kid == k.keyid():
             return k
         else:
-            raise ValueError, "Invalid Key ID"
+            raise ValueError("Invalid Key ID")
 
     # --- IDENTIFICATION AND VALIDATION ----------------------------------------
 
@@ -259,7 +260,7 @@ class Key:
             s = ecdsa.sign(h, self._priv)
             return enc_point(s)
         else:
-            raise AttributeError, "Private key needed for signing."
+            raise AttributeError("Private key needed for signing.")
 
     def verify(self, data, sig, hashfunc = 'sha256'):
         '''Verify the signature of data using the specified hash function'''
@@ -294,7 +295,7 @@ class Key:
         if source.verify(text, sgn):
             return text
         else:
-            raise SecurityViolationException, "Invalid Signature"
+            raise SecurityViolationException("Invalid Signature")
 
 
 if __name__ == "__main__":
@@ -302,7 +303,7 @@ if __name__ == "__main__":
     import time
 
     def test_overhead():
-        print "sender", "receiver", "+bytes", "+enctime", "+dectime"
+        print(("sender", "receiver", "+bytes", "+enctime", "+dectime"))
         for s in [192, 224, 256, 384, 521]:
             sender = Key.generate(s)
             for r in [192, 224, 256, 384, 521]:
@@ -313,7 +314,7 @@ if __name__ == "__main__":
                 t = time.time()
                 receiver.auth_decrypt(e, sender)
                 t2 = time.time() - t
-                print s, r, len(e), t1, t2
+                print((s, r, len(e), t1, t2))
 
                 
                 
diff --git a/python/PyECC/ecc/Rabbit.py b/python/PyECC/ecc/Rabbit.py
index 209f01e1ee..09a4a4994e 100644
--- a/python/PyECC/ecc/Rabbit.py
+++ b/python/PyECC/ecc/Rabbit.py
@@ -31,17 +31,17 @@ class Rabbit:
                 key = '\x00' * (16 - len(key)) + key
             # if len(key) > 16 bytes only the first 16 will be considered
             k = [ord(key[i + 1]) | (ord(key[i]) << 8)
-                 for i in xrange(14, -1, -2)]
+                 for i in range(14, -1, -2)]
         else:
             # k[0] = least significant 16 bits
             # k[7] = most significant 16 bits
-            k = [(key >> i) & 0xFFFF for i in xrange(0, 128, 16)]
+            k = [(key >> i) & 0xFFFF for i in range(0, 128, 16)]
             
         # State and counter initialization
         x = [(k[(j + 5) % 8] << 16) | k[(j + 4) % 8] if j & 1 else
-             (k[(j + 1) % 8] << 16) | k[j] for j in xrange(8)]
+             (k[(j + 1) % 8] << 16) | k[j] for j in range(8)]
         c = [(k[j] << 16) | k[(j + 1) % 8] if j & 1 else
-             (k[(j + 4) % 8] << 16) | k[(j + 5) % 8] for j in xrange(8)]
+             (k[(j + 4) % 8] << 16) | k[(j + 5) % 8] for j in range(8)]
         
         self.x = x
         self.c = c
@@ -49,12 +49,12 @@ class Rabbit:
         self._buf = 0           # output buffer
         self._buf_bytes = 0     # fill level of buffer
         
-        self.next()
-        self.next()
-        self.next()
-        self.next()
+        next(self)
+        next(self)
+        next(self)
+        next(self)
 
-        for j in xrange(8):
+        for j in range(8):
             c[j] ^= x[(j + 4) % 8]
         
         self.start_x = self.x[:]    # backup initial key for IV/reset
@@ -99,10 +99,10 @@ class Rabbit:
         c[6] ^= i2
         c[7] ^= i3
 
-        self.next()
-        self.next()
-        self.next()
-        self.next()
+        next(self)
+        next(self)
+        next(self)
+        next(self)
         
 
     def next(self):
@@ -130,7 +130,7 @@ class Rabbit:
         c[7] = t % WORDSIZE
         b = t // WORDSIZE
         
-        g = [_nsf(x[j], c[j]) for j in xrange(8)]
+        g = [_nsf(x[j], c[j]) for j in range(8)]
         
         x[0] = (g[0] + rot16(g[7]) + rot16(g[6])) % WORDSIZE
         x[1] = (g[1] + rot08(g[0]) + g[7]) % WORDSIZE
@@ -168,7 +168,7 @@ class Rabbit:
         next = self.next
         derive = self.derive
         
-        for i in xrange(n):
+        for i in range(n):
             if not j:
                 j = 16
                 next()
